#!/usr/bin/perl

push @INC,"/usr/local/ped";

#&DebugLog("------------------------------------------------\n");
#&DebugLog("Starting...\n");

require "keys.pl";
require "_Observee.pl";
require "_Buffer.pl";
require "Fundamental.pl";
require "MiniBuffer.pl";
require "_SGML.pl";
require "HTML.pl";
require "XML.pl";
require "View.pl";

#&DebugLog("Started\n");

View->DisplayBanner( <<BANNER

                                   Welcome  to

                                      P E D

                             For HELP type ESC : help
BANNER
	);

@argv=@ARGV;

# Create a default buffer
$firstBuffer = Fundamental->new if($#argv<0);

# Create a buffer for each command line arg
while($#argv>=0){
	my($filename) = shift @argv;
	my($class);
	#&DebugLog("Startup: new buffer for " . $filename . "\n");
#	$class = "SGML" if($filename =~ /(?i)\.sgml$/;
	$class = "Fundamental";
	$class = "HTML" if($filename =~ m/(?i)\.html$/);
	$class = "XML"  if($filename =~ m/(?i)\.xml$/);
	my($newbuf) = new $class;
	$newbuf->{"filename"} = $filename;
	$newbuf->{"buffername"} = $filename;
	$newbuf->ReReadFile;
	$firstBuffer = $newbuf if(!defined $firstBuffer);
}

new View ("full",$firstBuffer)->BecomeEditView;
$firstBuffer = undef;

# Main loop
while(! $done) {
	eval {
		View->WaitForInput;
		View->DispatchKeysToBuffer;
		View->UpdateDisplay;
	};
	if($@){
		&DebugLog("$@\n");
	}
}

exit;

sub ExitOnReturn {
	#&DebugLog("ExitOnReturn\n");
	$done = 1;
}

###################################
# Debug logic

# PUBLIC
sub DebugLog {
	open FILE, ">>".$INC[$#INC]."/debug.txt";
	print FILE @_;
	close FILE;
}

